import React, {Component} from 'react'
import PropTypes from 'prop-types'
import { is, fromJS } from 'immutable'
import { Modal } from 'antd'
import { MenuOutlined } from '@ant-design/icons'

import MenuTable from './menutable'
import './index.scss'

class DataSource extends Component {
  static propTpyes = {
    config: PropTypes.any,
    updateConfig: PropTypes.func
  }

  state = {
    visible: false
  }

  shouldComponentUpdate (nextProps, nextState) {
    return !is(fromJS(this.props), fromJS(nextProps)) || !is(fromJS(this.state), fromJS(nextState))
  }

  verifySubmit = () => {
    const { config } = this.props
    let menus = this.mTable.state.data || []

    this.props.updateConfig({...config, menus})
    this.setState({visible: false})
  }

  render () {
    const { config } = this.props
    const { visible } = this.state

    return (
      <div className="model-menu-setting-wrap">
        <MenuOutlined title="菜单" onClick={() => this.setState({ visible: true })}/>
        <Modal
          wrapClassName="popview-modal"
          title="菜单编辑"
          visible={visible}
          width={950}
          maskClosable={false}
          okText="提交"
          onOk={this.verifySubmit}
          onCancel={() => { this.setState({ visible: false }) }}
          destroyOnClose
        >
          <MenuTable
            menus={config.menus}
            ref={(ref) => { this.mTable = ref }}
          />
        </Modal>
      </div>
    )
  }
}

export default DataSource